-- Pour le bon fonctionnement de l'addon, merci de ne pas modifier le code
-- Sharas, le 130 juin 2010 - http://worldofwarcraft.judgehype.com

local JHC_GlobalOpeningTime = nil;
local JHC_GlobalOpeningAction = nil;
local JHC_GlobalOpeningSource = nil;
local JHC_GlobalEnteringWorld = nil;

local JHC_LastEvent = "";
local JHC_TotUpdate = 0;
local JHC_MaxUpdate = 3;

local JHC_LastQuestComplete = nil;
local JHC_LastQuestFinished = nil;
local JHC_LastQuestFinishedTime = 0;
local JHC_XP = nil;
local JHC_XPTime = 0;
local JHC_FactionGain = nil;
local JHC_FactionGainTime = 0;
local JHC_HonorGain = nil;
local JHC_HonorGainTime = 0;
local JHC_LastSellValue = 0;

-- ==============
-- ===== Captures
-- ==============

function JHC_Init()
	if not (GetLocale()=="frFR") then
		JHO_PurgeCollector();
		JH_Main.Collector = 0;
		JHO_CollectorCheckButton1:SetChecked(JH_Main.Collector);
		JH_Main.Calerte = 0;
		JHO_CollectorCheckButton2:SetChecked(JH_Main.Calerte);
		JH_Main.Cmetier = 0;
		JHO_CollectorCheckButton3:SetChecked(JH_Main.Cmetier);
		JHO_CollectorCheckButton2Text:SetTextColor(0.5, 0.5, 0.5);
		JHO_CollectorCheckButton3Text:SetTextColor(0.5, 0.5, 0.5);
		JHO_CollectorCheckButton2:Disable();
		JHO_CollectorCheckButton3:Disable();
	end
	JudgeHypeCollectorTooltip:SetOwner(UIParent, "ANCHOR_NONE");
	if JH_Main.Calerte==1 then
		JudgeHypeOptionsFrame:Show();
		JudgeHypeOnglet1UP:Show();
		JudgeHypeOnglet1DOWN:Hide();
		JudgeHypeOnglet2UP:Hide();
		JudgeHypeOnglet2DOWN:Show();
		JudgeHypeOnglet3UP:Hide();
		JudgeHypeOnglet3DOWN:Show();
		JudgeHypeOnglet4UP:Hide();
		JudgeHypeOnglet4DOWN:Show();
		JHO_GeneralFrame:Show();
		JHO_CollectorFrame:Hide();
		JHO_ProfilerFrame:Hide();
		JHO_TrackerFrame:Hide();
		JHO_GeneralPurgeButton1:LockHighlight();
	end
	-- JHC_OnTooltipAddMoneySaved = JudgeHypeTooltip:GetScript("OnTooltipAddMoney");
	-- JudgeHypeTooltip:SetScript("OnTooltipAddMoney", JHC_OnTooltipAddMoney);
end

function JHC_OnLoad()
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("PLAYER_LEAVING_WORLD");
end

function JHC_OnEvent(event,arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9,arg10,arg11,arg12,arg13,arg14,arg15,arg16,arg17,arg18,arg19)
	if JH_Main.Collector == 0 then return; end
	if event == "PLAYER_ENTERING_WORLD" then
		-- loot
		this:RegisterEvent("CHAT_MSG_OPENING");
		this:RegisterEvent("UNIT_SPELLCAST_SENT");
		this:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED");
		this:RegisterEvent("UNIT_SPELLCAST_FAILED");
		this:RegisterEvent("UNIT_SPELLCAST_STOP");
		this:RegisterEvent("ITEM_LOCK_CHANGED");
		this:RegisterEvent("ITEM_PUSH");
		this:RegisterEvent("LOOT_OPENED");
		this:RegisterEvent("LOOT_CLOSED");
		-- talk
		this:RegisterEvent("CHAT_MSG_MONSTER_WHISPER");
		this:RegisterEvent("CHAT_MSG_MONSTER_SAY");
		this:RegisterEvent("CHAT_MSG_MONSTER_YELL");
		this:RegisterEvent("CHAT_MSG_MONSTER_EMOTE");
		this:RegisterEvent("CHAT_MSG_RAID_BOSS_EMOTE");
		-- pnj interact
		this:RegisterEvent("MERCHANT_SHOW");
		this:RegisterEvent("MERCHANT_UPDATE");
		this:RegisterEvent("TRAINER_SHOW");
		this:RegisterEvent("BATTLEFIELDS_SHOW");
		this:RegisterEvent("BANKFRAME_OPENED");
		this:RegisterEvent("AUCTION_HOUSE_SHOW");
		this:RegisterEvent("PET_STABLE_SHOW");
		this:RegisterEvent("TAXIMAP_OPENED");
		this:RegisterEvent("GOSSIP_SHOW");
		this:RegisterEvent("PLAYER_TARGET_CHANGED");
		-- quete
		this:RegisterEvent("QUEST_LOG_UPDATE");
		this:RegisterEvent("QUEST_DETAIL");
		this:RegisterEvent("QUEST_PROGRESS");
		this:RegisterEvent("QUEST_COMPLETE");
		this:RegisterEvent("QUEST_FINISHED");
		this:RegisterEvent("CHAT_MSG_COMBAT_XP_GAIN");
		this:RegisterEvent("COMBAT_TEXT_UPDATE");
		-- craft
		this:RegisterEvent("TRADE_SKILL_SHOW");
		
		this:RegisterEvent("CRAFT_SHOW");
		-- divers
		this:RegisterEvent("ITEM_TEXT_READY");
		this:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
		this:RegisterEvent("UPDATE_FACTION");
		-- timer
		JHC_GlobalEnteringWorld = time();
		JHC_Debug("ENTERING WORLD : "..JHC_GlobalEnteringWorld);
	end
	if event == "PLAYER_LEAVING_WORLD" then
		-- loot
		this:UnregisterEvent("CHAT_MSG_OPENING");
		this:UnregisterEvent("UNIT_SPELLCAST_SENT");
		this:UnregisterEvent("UNIT_SPELLCAST_INTERRUPTED");
		this:UnregisterEvent("UNIT_SPELLCAST_FAILED");
		this:UnregisterEvent("UNIT_SPELLCAST_STOP");
		this:UnregisterEvent("ITEM_LOCK_CHANGED");
		this:UnregisterEvent("ITEM_PUSH");
		this:UnregisterEvent("LOOT_OPENED");
		this:UnregisterEvent("LOOT_CLOSED");
		-- talk
		this:UnregisterEvent("CHAT_MSG_MONSTER_WHISPER");
		this:UnregisterEvent("CHAT_MSG_MONSTER_SAY");
		this:UnregisterEvent("CHAT_MSG_MONSTER_YELL");
		this:UnregisterEvent("CHAT_MSG_MONSTER_EMOTE");
		this:UnregisterEvent("CHAT_MSG_RAID_BOSS_EMOTE");
		-- pnj interact
		this:UnregisterEvent("MERCHANT_SHOW");
		this:UnregisterEvent("MERCHANT_UPDATE");
		this:UnregisterEvent("TRAINER_SHOW");
		this:UnregisterEvent("BATTLEFIELDS_SHOW");
		this:UnregisterEvent("BANKFRAME_OPENED");
		this:UnregisterEvent("AUCTION_HOUSE_SHOW");
		this:UnregisterEvent("PET_STABLE_SHOW");
		this:UnregisterEvent("TAXIMAP_OPENED");
		this:UnregisterEvent("GOSSIP_SHOW");
		this:UnregisterEvent("PLAYER_TARGET_CHANGED");
		-- quete
		this:UnregisterEvent("QUEST_LOG_UPDATE");
		this:UnregisterEvent("QUEST_DETAIL");
		this:UnregisterEvent("QUEST_PROGRESS");
		this:UnregisterEvent("QUEST_COMPLETE");
		this:UnregisterEvent("QUEST_FINISHED");
		this:UnregisterEvent("CHAT_MSG_COMBAT_XP_GAIN");
		this:UnregisterEvent("COMBAT_TEXT_UPDATE");
		-- craft
		this:UnregisterEvent("TRADE_SKILL_SHOW");
		this:UnregisterEvent("CRAFT_SHOW");
		-- divers
		this:UnregisterEvent("ITEM_TEXT_READY");
		this:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
		this:UnregisterEvent("UPDATE_FACTION");
	end
	if not (GetLocale()=="frFR") then
		JH_Main.Collector = 0;
		JHO_CollectorCheckButton1:SetChecked(JH_Main.Collector);
		JH_Main.Calerte = 0;
		JHO_CollectorCheckButton2:SetChecked(JH_Main.Calerte);
		JH_Main.Cmetier = 0;
		JHO_CollectorCheckButton3:SetChecked(JH_Main.Cmetier);
		JHO_CollectorCheckButton2Text:SetTextColor(0.5, 0.5, 0.5);
		JHO_CollectorCheckButton3Text:SetTextColor(0.5, 0.5, 0.5);
		JHO_CollectorCheckButton2:Disable();
		JHO_CollectorCheckButton3:Disable();
		JHO_PurgeCollector();
		return;
	end
	if time() > (JHC_GlobalEnteringWorld+5) then
		-- loot
		if event == "CHAT_MSG_OPENING" then JHC_Opening(arg1); end
		if event == "UNIT_SPELLCAST_SENT" then JHC_SpellSent(arg1,arg2,arg3,arg4); end
		if event == "UNIT_SPELLCAST_INTERRUPTED" then JHC_ResetTimers(); end
		if event == "UNIT_SPELLCAST_FAILED" then JHC_ResetTimers(); end
		if event == "UNIT_SPELLCAST_STOP" then JHC_SpellStop(arg1,arg2); end
		if event == "ITEM_LOCK_CHANGED" then JHC_Lock(arg1,arg2); end
		if event == "ITEM_PUSH" then JHC_ScanBag(); end
		if event == "LOOT_OPENED" then JHC_LootOpened(); end
		if event == "LOOT_CLOSED" then JHC_ResetTimers(); end
		-- talk
		if event == "CHAT_MSG_MONSTER_WHISPER" then JHC_MonsterTalk("WHISPER",arg1,arg2,arg3); end
		if event == "CHAT_MSG_MONSTER_SAY" then JHC_MonsterTalk("SAY",arg1,arg2,arg3); end
		if event == "CHAT_MSG_MONSTER_YELL" then JHC_MonsterTalk("YELL",arg1,arg2,arg3); end
		if event == "CHAT_MSG_MONSTER_EMOTE" then JHC_MonsterTalk("EMOTE",arg1,arg2,arg3); end
		if event == "CHAT_MSG_RAID_BOSS_EMOTE" then JHC_MonsterTalk("BOSS",arg1,arg2,arg3); end
		-- pnj interact
		if event == "MERCHANT_SHOW" then
			JHC_ScanBag();
			JHC_Shop();
			-- JHC_ShopSell();
		end
		if event == "MERCHANT_UPDATE" then JHC_Shop(); end
		if event == "TRAINER_SHOW" then JHC_Trainer(); end
		if event == "BATTLEFIELDS_SHOW" then JHC_Target(); end
		if event == "BANKFRAME_OPENED" then JHC_Target(); JHC_ScanBag(); end
		if event == "AUCTION_HOUSE_SHOW" then JHC_Target(); end
		if event == "PET_STABLE_SHOW" then JHC_Target(); end
		if event == "TAXIMAP_OPENED" then JHC_Target(); end
		if event == "GOSSIP_SHOW" then JHC_Target(); end
		if event == "PLAYER_TARGET_CHANGED" then JHC_Target(); end
		-- quete
		if event == "QUEST_LOG_UPDATE" then
			if JHC_MaxUpdate > JHC_TotUpdate then
				JHC_QuestUpdate();
			end
		end
		if event == "QUEST_DETAIL" then JHC_QuestDetail(); end
		if event == "QUEST_PROGRESS" then JHC_QuestProgress(); end
		if event == "QUEST_COMPLETE" then JHC_QuestComplete(arg1); end
		if event == "QUEST_FINISHED" then JHC_QuestFinished(arg1); end
		if event == "CHAT_MSG_COMBAT_XP_GAIN" then JHC_XPGain(arg1); end
		if event == "COMBAT_TEXT_UPDATE" then JHC_CombatTxt(arg1,arg2,arg3); end
		-- craft
		if event == "TRADE_SKILL_SHOW" and JH_Main.Cmetier == 1 then JHC_Tradeskill(); end
		-- divers
		if event == "ITEM_TEXT_READY" then JHC_Reader(); end
		if event == "COMBAT_LOG_EVENT_UNFILTERED" then JHC_SelfDamage(arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9,arg10,arg11,arg12,arg13,arg14,arg15,arg16,arg17,arg18,arg19); end
		if event == "UPDATE_FACTION" then JHC_SaveFactions(); end
	else
		-- JHC_Debug("NO EVENT ALLOWED : "..time().." vs"..JHC_GlobalEnteringWorld);
	end

	if JHC_LastEvent == event then
		JHC_TotUpdate = JHC_TotUpdate + 1;
	else
		JHC_TotUpdate = 0;
	end
	JHC_LastEvent = event;
end

-- ============
-- ===== Cibles
-- ============

function JHC_Target()
	if UnitReaction("target","player") == nil then
		JHC_Debug("TARGET OUT : UnitReaction");
		return nil;
	elseif UnitName("target") == "Inconnu" then
		JHC_Debug("TARGET OUT : UnitName");
		return nil;
	elseif UnitName("target") == "" then
		JHC_Debug("TARGET OUT : UnitName");
		return nil;
	elseif UnitName("target") == nil then
		JHC_Debug("TARGET OUT : UnitName");
		return nil;
	elseif UnitIsPlayer("target") then
		JHC_Debug("TARGET OUT : UnitIsPlayer");
		return nil;
	elseif UnitPlayerControlled("target") then
		JHC_Debug("TARGET OUT : UnitPlayerControlled");
		return nil;
	elseif UnitIsCharmed("player") then
		JHC_Debug("TARGET OUT : UnitIsCharmed");
		return nil;
	elseif not UnitExists("target") then
		JHC_Debug("TARGET OUT : UnitExists");
		return nil;
	elseif not CheckInteractDistance("target", 2) then
	 	JHC_Debug("TARGET OUT : CheckInteractDistance");
		return nil;
	elseif UnitCanAttack("player", "target") then
		JHC_Debug("TARGET : UnitCanAttack +"..UnitName("target").."+");
		JHC_Ennemy();
		return JHC_CleanMe(UnitName("target"));
	elseif  UnitIsFriend("player","target") then
		JHC_Debug("TARGET : UnitIsFriend +"..UnitName("target").."+");
		JHC_Friendly();
		return;
	elseif UnitReaction("player", "target") == 4 then
		JHC_Debug("TARGET : !UNITREACTION! +"..UnitName("target").."+");
		JHC_Friendly("4");
		return;
	else
		return nil;
	end
end

function JHC_Friendly(reaction)
	local target = JHC_CleanMe(UnitName("target"));
	local rz, sz, x, y, cont, wx, wy, dl = JHC_GetInfoLoc();
	local report = "pnj_"..target.."_"..rz;
	if not JH_Collector.pnjs[report] then
		JH_Collector.pnjs[report] = {};
		local uleve = UnitLevel("target");
		local uclas = JHC_CleanMe(UnitClassBase("target"));
		local uclaf = JHC_CleanMe(UnitClassification("target"));
		local utype = JHC_CleanMe(UnitCreatureType("target"));
		local ufact = JHC_CleanMe(UnitFactionGroup("player"));
		local urepa = "0"; if CanMerchantRepair("target") then urepa = "1"; end
		local npcid = JHC_GetUnitId("target");
		JH_Collector.pnjs[report].pnjinfos = target.."||"..uleve.."||"..uclas.."||"..uclaf.."||"..utype.."||"..ufact.."||"..urepa;
		if npcid ~= nil then
			JH_Collector.pnjs[report].pnjid = npcid;
		end
		if reaction == "4" then
			JH_Collector.pnjs[report].pnjreaction = "4";
		end
		JHC_DumpTooltip("target","");
		JH_Collector.pnjs[report].pnjttip = JHC_GetTooltip();
		JHO_DumpCoList("pnjs",UnitName("target"));
	else
		if JH_Collector.pnjs[report].pnjttip == "" then
			JHC_DumpTooltip("target","");
			JH_Collector.pnjs[report].pnjtitle = JHC_GetTooltip();
		end
	end
	JHC_Location("pnjs",report,rz,sz,x,y,cont,wx,wy,dl);
	JHC_Debug("TARGET : pnj +"..target.."+"..JHC_GetUnitId("target").."+");
	-- JHC_GetDifficulty();
end

function JHC_Ennemy()
	local target = JHC_CleanMe(UnitName("target"));
	local rz, sz, x, y, cont, wx, wy, dl = JHC_GetInfoLoc();
	local report = "mob_"..target;
	if UnitClassification("target") == "worldboss" then
		report = report.."_worldboss";
	end
	if not JH_Collector.monstres[report] then
		JH_Collector.monstres[report] = {};
		local uleve = UnitLevel("target");
		local ufami = JHC_CleanMe(UnitCreatureFamily("target"));
		local utype = JHC_CleanMe(UnitCreatureType("target"));
		local uclaf = JHC_CleanMe(UnitClassification("target"));
		local uplus = 0;
		local upvp = 0;
		if UnitIsPVP("target") then
			upvp = 1;
			JHC_Debug("PVP : mob +"..target.."+");
		end
		local upowe = UnitPowerType("target");
		local umaxm = UnitManaMax("target");
		local umaxh = UnitHealthMax("target");
		local _, instanceType = IsInInstance();
		if ufami == "" then ufami="NULL"; end
		if utype == "" then utype="NULL"; end
		if uclaf == "" then uclaf="NULL"; end
		JH_Collector.monstres[report].mobinfos = target.."||"..ufami.."||"..utype.."||"..uclaf.."||"..uplus.."||"..upvp.."||"..upowe.."||"..umaxm.."||"..umaxh;
		JH_Collector.monstres[report].moblvl = uleve.."||"..uleve;
		JH_Collector.monstres[report].mobzone = instanceType.."||"..rz;
		JH_Collector.monstres[report].sous = "0||0";
		JH_Collector.monstres[report].mobkilled = "0||0||0||0||0";
		local mobid = JHC_GetUnitId("target");
		if mobid ~= nil then
			JH_Collector.monstres[report].mobid = mobid;
		end
		JHC_DumpTooltip("target","");
		JH_Collector.monstres[report].mobttip = JHC_GetTooltip();
		JHO_DumpCoList("monstres",UnitName("target"));
	else
		if JH_Collector.monstres[report].mobttip == "" then
			JHC_DumpTooltip("target","");
			JH_Collector.monstres[report].mobttip = JHC_GetTooltip();
		end
		for a, b in string.gmatch(JH_Collector.monstres[report].moblvl, "(%d+)||(%d+)") do
			if tonumber(b)<UnitLevel("target") then b = UnitLevel("target"); end
			if tonumber(a)>UnitLevel("target") then a = UnitLevel("target"); end
			local newstring = a.."||"..b;
			JH_Collector.monstres[report].moblvl = newstring;
		end
	end
	JHC_Location("monstres",report,rz,sz,x,y,cont,wx,wy,dl);
	JHC_Debug("TARGET : mob +"..target.."+"..JHC_GetUnitId("target").."+");
end

function JHC_Inerte()
	if UnitReaction("npc","player") == nil then
		local cible = JHC_CleanMe(UnitName("npc"));
		local rz, sz, x, y, cont, wx, wy, dl = JHC_GetInfoLoc();
		local report = "inerte_"..cible.."_"..rz;
		if cible == "Inconnu" or cible == "" or cible == nil then
			return nil;
		else
			if not JH_Collector.inertes[report] then
				JH_Collector.inertes[report] = {};
				JH_Collector.inertes[report].inerteinfos = cible;
				JHO_DumpCoList("inertes",UnitName("npc"));
			end
			JHC_Location("inertes",report,rz,sz,x,y,cont,wx,wy,dl);
			JHC_Debug("TARGET : inerte +"..cible.."+");
			return "inertes",report,target;
		end
	end
	return nil;
end

-- ==========
-- ===== LOOT
-- ==========

function JHC_Opening(val1)
	local _,_,what,who = string.find(val1, "Vous ex\195\169cutez (.*) sur (.*).");
	if what == "Minage" or what == "Cueillette" then
		if what and who then
			JHC_GlobalOpeningTime = GetTime();
			JHC_GlobalOpeningAction = what;
			JHC_GlobalOpeningSource = who;
			JHC_Debug("OPENING +"..what.."+ +"..who.."+");
		end
	end
end

function JHC_SpellSent(val1,val2,val3,val4)
	if val1 == "player" then
		if string.find(val2,"Ouverture") or val2 == "Ouverture" or val2 == "Crochetage" or val2 == "D\195\169pe\195\167age" or val2 == "Vol \195\160 la tire" then
			JHC_GlobalOpeningTime = GetTime();
			JHC_GlobalOpeningAction = val2;
			JHC_GlobalOpeningSource = val4;
			JHC_Debug("SPELLSENT +"..val2.."+ +"..val4.."+"..JHC_GlobalOpeningTime);
		end
		if val2 == "D\195\169senchanter" or val2 == "Prospection" or val2 == "Mouture" then
			JHC_GlobalOpeningTime = GetTime();
			JHC_GlobalOpeningAction = val2;
			JHC_GlobalOpeningSource = nil;
			JHC_Debug("SPELLSENT +"..val2.."+");
		end
		if val2 == "Minage" and UnitCanAttack("player", "target") and val4 == UnitName("target") and UnitIsDead("target") then
			JHC_GlobalOpeningTime = GetTime();
			JHC_GlobalOpeningAction = "Minage";
			JHC_GlobalOpeningSource = val4;
			JHC_Debug("SPELLSENT +Minage_Dead+");
		end
		if val2 == "Cueillette" and UnitCanAttack("player", "target") and val4 == UnitName("target") and UnitIsDead("target") then
			JHC_GlobalOpeningTime = GetTime();
			JHC_GlobalOpeningAction = "Cueillette";
			JHC_GlobalOpeningSource = val4;
			JHC_Debug("SPELLSENT +Cueillette_Dead+");
		end
	else
		JHC_ResetTimers();
	end
end

function JHC_SpellStop(val1,val2)
	if JHC_GlobalOpeningTime ~= nil or JHC_GlobalOpeningAction ~= nil or JHC_GlobalOpeningSource ~= nil then
		if val1 == "player" then
			if val2 == nil or val2 ~= JHC_GlobalOpeningAction then
				JHC_ResetTimers();
			else
				JHC_GlobalOpeningTime = GetTime();
				JHC_Debug("SPELLSTOP +"..val2.."+"..JHC_GlobalOpeningTime);
			end
		end
	end
end

function JHC_Lock(val1,val2)
	JHC_Debug("LOCKEDWORK");
	if JHC_GlobalOpeningAction == "D\195\169senchanter" or JHC_GlobalOpeningAction == "Prospection" or JHC_GlobalOpeningAction == "Mouture" then
		if val1 ~= nil and val2 ~= nil then
			local BagitemLink = GetContainerItemLink(val1, val2);
			if BagitemLink then
				JHC_ProcessItem(BagitemLink);
				local id, sousid;
				for id, sousid in string.gmatch(BagitemLink, "|c%x+|Hitem:(%d+):%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:(%-?%d+):%-?%d+:%-?%d+|h%[.-%]|h|r") do
					JHC_GlobalOpeningTime = GetTime();
					JHC_GlobalOpeningSource = id..":"..sousid;
					JHC_Debug("LOCKED +"..BagitemLink.."+");
				end
			end
		end
	else
		JHC_ResetTimers();
	end
end

function JHC_InItem()
	local lockedTot = 0;
	local lockedbagNum = nil;
	local lockedbagItem = nil;
	for bagNum = 0, 4 do
		local bagname = GetBagName(bagNum);
		local bagNum_Slots = GetContainerNumSlots(bagNum);
		if bagname then
			for bagItem = 1, bagNum_Slots do
				local BagitemLink = GetContainerItemLink(bagNum, bagItem);
				if BagitemLink then
					local _, _, locked, _, _ = GetContainerItemInfo(bagNum, bagItem);
					if locked then
						GameTooltip:SetBagItem(bagNum, bagItem);
						for i=1, GameTooltip:NumLines() do
							local TextLeft = getglobal("GameTooltipTextLeft"..i):GetText()
							if TextLeft == "<Clic droit pour ouvrir>" then
								lockedTot = lockedTot + 1;
								lockedbagNum = bagNum;
								lockedbagItem = bagItem;
							end
						end
					end
				end
			end
		end
	end
	if lockedTot == 1 and lockedbagNum and lockedbagItem then
		local BagitemLink = GetContainerItemLink(lockedbagNum, lockedbagItem);
		if BagitemLink then
			JHC_ProcessItem(BagitemLink);
			local id, sousid;
			for id, sousid in string.gmatch(BagitemLink, "|c%x+|Hitem:(%d+):%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:(%-?%d+):%-?%d+:%-?%d+|h%[.-%]|h|r") do
				JHC_GlobalOpeningAction = "Clic droit pour ouvrir";
				JHC_GlobalOpeningTime = GetTime();
				JHC_GlobalOpeningSource = id..":"..sousid;
				JHC_Debug("INITEM +"..BagitemLink.."+");
			end
		end
	end
end

function JHC_LootOpened()
	local nbloot = GetNumLootItems();
	--if nbloot == 0 then
	--	JHC_ResetTimers();
	--	return;
	--end
	local type = nil;
	local report = nil;
	if JHC_GlobalOpeningTime ~= nil and JHC_GlobalOpeningAction ~= nil and JHC_GlobalOpeningSource ~= nil then	
		local _, _, lag = GetNetStats();
		local Maxtime = JHC_GlobalOpeningTime + (lag/1000) + 1;
		JHC_Debug("IF Maxtime="..Maxtime.." > GetTime="..GetTime());
		if Maxtime > GetTime() then
		-- ======= Ouverture/Minage/Cueillette/Dead =======
			if string.find(JHC_GlobalOpeningSource,"Ouverture") or JHC_GlobalOpeningAction == "Ouverture" or JHC_GlobalOpeningAction == "Crochetage" or JHC_GlobalOpeningAction == "Minage" or JHC_GlobalOpeningAction == "Cueillette" or JHC_GlobalOpeningAction == "Minage_Dead" or JHC_GlobalOpeningAction == "Cueillette_Dead" then
				type="box";
				report = "box_"..JHC_CleanMe(JHC_GlobalOpeningSource);
				local rz, sz, x, y, cont, wx, wy, dl = JHC_GetInfoLoc();
				if not JH_Collector.box[report] then
					JH_Collector.box[report] = {};
					JH_Collector.box[report].boxinfos = JHC_CleanMe(JHC_GlobalOpeningSource).."||"..JHC_CleanMe(JHC_GlobalOpeningAction);
					JH_Collector.box[report].sous = "0||0";
					JH_Collector.box[report].boxlooted = "0||0||0||0||0";
					JHO_DumpCoList("containers",JHC_GlobalOpeningSource);
				end
				local difficulty = JHC_GetDifficulty();
				local da,db,dc,dd,de;
				for da, db, dc, dd, de in string.gmatch(JH_Collector.box[report].boxlooted, "(%d+)||(%d+)||(%d+)||(%d+)||(%d+)") do
					if difficulty == 0 then
						da = tonumber(da)+1;
					elseif difficulty == 1 then
						db = tonumber(db)+1;
					elseif difficulty == 2 then
						dc = tonumber(dc)+1;
					elseif difficulty == 3 then
						dd = tonumber(dd)+1;
					elseif difficulty == 4 then
						de = tonumber(de)+1;
					end
					local newstring = da.."||"..db.."||"..dc.."||"..dd.."||"..de;
					JH_Collector.box[report].boxlooted = newstring;
				end
				JHC_Location("box",report,rz,sz,x,y,cont,wx,wy,dl);
		-- ======= Depecage =======
			elseif JHC_GlobalOpeningAction == "D\195\169pe\195\167age" then
				type="dep";
				report="dep_"..JHC_CleanMe(JHC_GlobalOpeningSource);
				if not JH_Collector.dep[report] then
					JH_Collector.dep[report] = {};
					JH_Collector.dep[report].depinfos = JHC_CleanMe(JHC_GlobalOpeningSource).."||"..JHC_CleanMe(JHC_GlobalOpeningAction);
					JH_Collector.dep[report].sous = "0||0";
					JH_Collector.dep[report].deplooted = "0||0||0||0||0";
				end
				local difficulty = JHC_GetDifficulty();
				local da,db,dc,dd,de;
				for da, db, dc, dd, de in string.gmatch(JH_Collector.dep[report].deplooted, "(%d+)||(%d+)||(%d+)||(%d+)||(%d+)") do
					if difficulty == 0 then
						da = tonumber(da)+1;
					elseif difficulty == 1 then
						db = tonumber(db)+1;
					elseif difficulty == 2 then
						dc = tonumber(dc)+1;
					elseif difficulty == 3 then
						dd = tonumber(dd)+1;
					elseif difficulty == 4 then
						de = tonumber(de)+1;
					end
					local newstring = da.."||"..db.."||"..dc.."||"..dd.."||"..de;
					JH_Collector.dep[report].deplooted = newstring;
				end
		-- ======= Vol a la tire =======
			elseif JHC_GlobalOpeningAction == "Vol \195\160 la tire" then
				type="vol";
				report = "vol_"..JHC_CleanMe(JHC_GlobalOpeningSource);
				if not JH_Collector.vol[report] then
					JH_Collector.vol[report] = {};
					JH_Collector.vol[report].volinfos = JHC_CleanMe(JHC_GlobalOpeningSource).."||"..JHC_CleanMe(JHC_GlobalOpeningAction);
					JH_Collector.vol[report].sous = "0||0";
					JH_Collector.vol[report].vollooted = "0||0||0||0||0";
				end
				local difficulty = JHC_GetDifficulty();
				local da,db,dc,dd,de;
				for da, db, dc, dd, de in string.gmatch(JH_Collector.vol[report].vollooted, "(%d+)||(%d+)||(%d+)||(%d+)||(%d+)") do
					if difficulty == 0 then
						da = tonumber(da)+1;
					elseif difficulty == 1 then
						db = tonumber(db)+1;
					elseif difficulty == 2 then
						dc = tonumber(dc)+1;
					elseif difficulty == 3 then
						dd = tonumber(dd)+1;
					elseif difficulty == 4 then
						de = tonumber(de)+1;
					end
					local newstring = da.."||"..db.."||"..dc.."||"..dd.."||"..de;
					JH_Collector.vol[report].vollooted = newstring;
				end
		-- ======= Desenchanter =======
			elseif JHC_GlobalOpeningAction == "D\195\169senchanter" then
				type="dis";
				report = "dis_"..JHC_CleanMe(JHC_GlobalOpeningSource);
				if not JH_Collector.dis[report] then
					JH_Collector.dis[report] = {};
					JH_Collector.dis[report].disinfos = JHC_CleanMe(JHC_GlobalOpeningSource);
					JH_Collector.dis[report].sous = "0||0";
					JH_Collector.dis[report].dislooted = 1;
				else
					local CurrentCount = JH_Collector.dis[report].dislooted +1;
					JH_Collector.dis[report].dislooted = CurrentCount;
				end
		-- ======= Prospection =======
			elseif JHC_GlobalOpeningAction == "Prospection" then
				type="pro";
				report = "pro_"..JHC_CleanMe(JHC_GlobalOpeningSource);
				if not JH_Collector.pro[report] then
					JH_Collector.pro[report] = {};
					JH_Collector.pro[report].proinfos = JHC_CleanMe(JHC_GlobalOpeningSource);
					JH_Collector.pro[report].sous = "0||0";
					JH_Collector.pro[report].prolooted = 1;
				else
					local CurrentCount = JH_Collector.pro[report].prolooted +1;
					JH_Collector.pro[report].prolooted = CurrentCount;
				end
		-- ======= Mouture =======
			elseif JHC_GlobalOpeningAction == "Mouture" then
				type="mou";
				report = "mou_"..JHC_CleanMe(JHC_GlobalOpeningSource);
				if not JH_Collector.mou[report] then
					JH_Collector.mou[report] = {};
					JH_Collector.mou[report].mouinfos = JHC_CleanMe(JHC_GlobalOpeningSource);
					JH_Collector.mou[report].sous = "0||0";
					JH_Collector.mou[report].moulooted = 1;
				else
					local CurrentCount = JH_Collector.mou[report].moulooted +1;
					JH_Collector.mou[report].moulooted = CurrentCount;
				end
			end
			if type == nil then
				JHC_ResetTimers();
				JHC_Debug("type nil ...");
			else
				JHC_Debug("OPENED +"..type.."+ : +"..JHC_GlobalOpeningSource.."+ WITH +"..JHC_GlobalOpeningAction.."+");
			end
		end
	end
	JHC_ResetTimers();
	-- ======= Peche =======
	if IsFishingLoot() then
		type="fishing";
		local rz, sz, x, y, cont, wx, wy, dl = JHC_GetInfoLoc();
		report = "fish_"..rz.."_"..sz;
		if not JH_Collector.fishing[report] then
			JH_Collector.fishing[report] = {};
			JH_Collector.fishing[report].fishlooted = 1;
			JH_Collector.fishing[report].sous = "0||0";
			JH_Collector.fishing[report].fishinfos = rz.."||"..sz;
		else
			local CurrentCount = JH_Collector.fishing[report].fishlooted +1;
			JH_Collector.fishing[report].fishlooted = CurrentCount;
		end
		JHC_Location("fishing",report,rz,sz,x,y,cont,wx,wy,dl);
		JHC_Debug("OPENED +"..type.."+ : +"..report.."+");
	end
	-- ======= Clic droit pour ouvrir =======
	if type == nil then
		JHC_InItem();
	end
	if JHC_GlobalOpeningTime ~= nil and JHC_GlobalOpeningAction ~= nil and JHC_GlobalOpeningSource ~= nil then
		JHC_Debug("doing in item2 ...");
		if JHC_GlobalOpeningAction == "Clic droit pour ouvrir" then
			type="foundin";
			report = "foundin_"..JHC_GlobalOpeningSource;
			if not JH_Collector.foundin[report] then
				JH_Collector.foundin[report] = {};
				JH_Collector.foundin[report].foundininfos = JHC_GlobalOpeningSource;
				JH_Collector.foundin[report].sous = "0||0";
				JH_Collector.foundin[report].foundinlooted = 1;
			else
				local CurrentCount = JH_Collector.foundin[report].foundinlooted +1;
				JH_Collector.foundin[report].foundinlooted = CurrentCount;
			end
		end
	end
	-- ======= Monstres =======
	if type == nil then
		local hastarget = nil;
		hastarget = JHC_Target();
		if hastarget ~= nil then
			type = "monstres";
			report = "mob_"..hastarget;
			if UnitClassification("target") == "worldboss" then
				report = report.."_worldboss";
			end
			if JH_Collector.monstres[report].mobkilled then
				local difficulty = JHC_GetDifficulty();
				local da,db,dc,dd,de;
				for da, db, dc, dd, de in string.gmatch(JH_Collector.monstres[report].mobkilled, "(%d+)||(%d+)||(%d+)||(%d+)||(%d+)") do
					if difficulty == 0 then
						da = tonumber(da)+1;
					elseif difficulty == 1 then
						db = tonumber(db)+1;
					elseif difficulty == 2 then
						dc = tonumber(dc)+1;
					elseif difficulty == 3 then
						dd = tonumber(dd)+1;
					elseif difficulty == 4 then
						de = tonumber(de)+1;
					end
					local newstring = da.."||"..db.."||"..dc.."||"..dd.."||"..de;
					JH_Collector.monstres[report].mobkilled = newstring;
				end
				JHC_Debug("OPENED +"..type.."+ : +"..hastarget.."+");
			else
				return;
			end
		end
	end
	if type ~= nil and report ~= nil then
		for i=1, nbloot, 1 do
			if LootSlotIsCoin(i) then
				local totalsous = 0;
				local _, item, _, _ = GetLootSlotInfo(i);
				local _,_,cuivreloot = string.find(item,"(%d+) Cuivre");
				if (cuivreloot) then totalsous = totalsous+cuivreloot; end
				local _,_,argentloot = string.find(item,"(%d+) Argent");
				if (argentloot) then totalsous = totalsous+(argentloot*100); end
				local _,_,orloot = string.find(item,"(%d+) Or");
				if orloot then totalsous = totalsous+(orloot*10000); end
				if JH_Collector[type][report].sous == "0||0" then
					JH_Collector[type][report].sous = totalsous.."||"..totalsous;
				else
					local a,b;
					for a, b in string.gmatch(JH_Collector[type][report].sous, "(%d+)||(%d+)") do
						if tonumber(b)<totalsous then b = totalsous; end
						if tonumber(a)>totalsous then a = totalsous; end
						local newstring = a.."||"..b;
						JH_Collector[type][report].sous = newstring;
					end
				end
			end
			if LootSlotIsItem(i) then
				local _, _, quantity, _ = GetLootSlotInfo(i);
				local link = GetLootSlotLink(i);
				if link then
					local itemreport = JHC_ProcessItem(link);
					if itemreport then
						if JH_Collector[type][report] then
							if not JH_Collector[type][report]["droplist"] then
								JH_Collector[type][report]["droplist"] = {}
							end
							local difficulty = JHC_GetDifficulty();
							JHC_Debug("LOOT +"..link.."+ +"..report.."+ d="..difficulty);
							if not JH_Collector[type][report]["droplist"]["drop_"..itemreport.."_"..difficulty] then
								JH_Collector[type][report]["droplist"]["drop_"..itemreport.."_"..difficulty] = "1||"..quantity.."||"..quantity.."||"..itemreport.."||"..difficulty;
							else
								local a,b,c,d,e,f;
								for a, b, c, d, e, f in string.gmatch(JH_Collector[type][report]["droplist"]["drop_"..itemreport.."_"..difficulty], "(%d+)||(%d+)||(%d+)||(%d+):(%d+)||(%d+)") do
									a = tonumber(a)+1;
									if quantity < tonumber(b) then b = quantity; end
									if quantity > tonumber(c) then c = quantity; end
									local newstring = a.."||"..b.."||"..c.."||"..d..":"..e.."||"..f;
									JH_Collector[type][report]["droplist"]["drop_"..itemreport.."_"..difficulty] = newstring;
								end
							end
						end
					end
				end
			end
		end
	end
	JHC_ResetTimers();
end

-- ============
-- ===== Quetes
-- ============

function JHC_QuestDetail()
	JHC_Target();
	local source = JHC_GetQuestSource();
	if source == nil then
		return;
	end
	local JHcp = JHC_CleanMe(UnitName("player")).."||"..JHC_CleanMe(GetCVar("realmName"));
	local QuestTitre = JHC_CleanMe(JHC_CleanLevel(GetTitleText()));
	local QuestObj = JHC_CleanMe(GetObjectiveText());
	local QuestTexte = JHC_CleanMe(GetQuestText());
	local spelltexture, spellname, isTradeskillSpell, _ = GetRewardSpell();
	if isTradeskillSpell then isTradeskillSpell=1; else isTradeskillSpell=0; end
	local idquest = JHC_GetQuestID(JHcp,QuestTitre,QuestObj,QuestTexte);
	if idquest == nil then
		idquest = JH_Main.totquest + 1;
		JH_Main.totquest = idquest;
		JH_Collector.quetes["newquete_"..idquest] = {};
		JH_Collector.quetes["newquete_"..idquest].qtinsta = 0;
		JH_Collector.quetes["newquete_"..idquest].qtlog = 0;
		JH_Collector.quetes["newquete_"..idquest].qtwho = JHcp;
		JH_Collector.quetes["newquete_"..idquest].qttitre = QuestTitre;
		JH_Collector.quetes["newquete_"..idquest].qtobj = QuestObj;
		JH_Collector.quetes["newquete_"..idquest].qttexte = QuestTexte;
		JH_Collector.quetes["newquete_"..idquest].qtsource = source;
		JH_Collector.quetes["newquete_"..idquest].qtside = UnitFactionGroup("player").."||"..UnitClass("player").."||"..UnitRace("player");
		JH_Collector.quetes["newquete_"..idquest].qtll = UnitLevel("player").."||"..GetRewardMoney();
		JH_Collector.quetes["newquete_"..idquest].qthl = UnitLevel("player").."||"..GetRewardMoney();
		local moneytoget = GetQuestMoneyToGet();
		if moneytoget > 0 then
			JH_Collector.quetes["newquete_"..idquest].qtgsous = moneytoget;
		end
		local reward = JHC_GetQReward();
		if reward ~= nil then
			JH_Collector.quetes["newquete_"..idquest].qtreward = listreward;
		end
		if spelltexture then
			spelltexture = string.gsub(spelltexture,"Interface\\Icons\\","");
			local spellinfo = JHC_CleanMe(spellname).."||"..spelltexture.."||"..isTradeskillSpell;
			JH_Collector.quetes["newquete_"..idquest].qtspell = spellinfo;
		end
		if JHC_LastQuestFinishedTime+0.5 > GetTime() then
			if JHC_LastQuestFinished then
				if JH_Collector.quetes["newquete_"..JHC_LastQuestFinished] then
					if JH_Collector.quetes["newquete_"..JHC_LastQuestFinished].qtobj ~= nil then
						JH_Collector.quetes["newquete_"..idquest].qtsuite = JH_Collector.quetes["newquete_"..JHC_LastQuestFinished].qttitre.."||"..JH_Collector.quetes["newquete_"..JHC_LastQuestFinished].qtobj;
					end
				end
			end
		end
		JHO_DumpCoList("quetes",JHC_CleanLevel(GetTitleText()));
	end
end

function JHC_QuestUpdate()
	for i=1, JH_Main.totquest, 1 do
		JH_Collector.quetes["newquete_"..i].qtlog = 0;
	end
	local CurrentHeader;
	local JHcp = JHC_CleanMe(UnitName("player")).."||"..JHC_CleanMe(GetCVar("realmName"));
	for i=1, GetNumQuestLogEntries(), 1 do
		local questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily = GetQuestLogTitle(i);
		if isHeader then
			CurrentHeader = JHC_CleanMe(JHC_CleanLevel(questLogTitleText));
		else
			SelectQuestLogEntry(i);
			if questTag == nil then
				questTag="Normal";
			end
			if isDaily and questTag then
				isDaily = 1;
			else
				isDaily = 0;
			end
			local questId,questLvl = JHC_GetQuestId(GetQuestLink(i));
			local questDescription, questObjectives = GetQuestLogQuestText();
			local QuestTitre = JHC_CleanMe(JHC_CleanLevel(questLogTitleText));
			local QuestObj = JHC_CleanMe(questObjectives);
			local QuestTexte = JHC_CleanMe(questDescription);
			local spellTexture, spellName, isTradeskillSpell = GetQuestLogRewardSpell();
			if isTradeskillSpell then isTradeskillSpell=1; else isTradeskillSpell=0; end
			local idquest = JHC_GetQuestID(JHcp,QuestTitre,QuestObj,QuestTexte);
			if idquest == nil then
				idquest = JH_Main.totquest + 1;
				JH_Main.totquest = idquest;
				JH_Collector.quetes["newquete_"..idquest] = {};
				JH_Collector.quetes["newquete_"..idquest].qtid = questId.."||"..questLvl;
				JH_Collector.quetes["newquete_"..idquest].qtinsta = 0;
				JH_Collector.quetes["newquete_"..idquest].qdaily = isDaily;
				JH_Collector.quetes["newquete_"..idquest].qtwho = JHcp;
				JH_Collector.quetes["newquete_"..idquest].qttitre = QuestTitre;
				JH_Collector.quetes["newquete_"..idquest].qtobj = QuestObj;
				JH_Collector.quetes["newquete_"..idquest].qttexte = QuestTexte;
				JH_Collector.quetes["newquete_"..idquest].qtside = UnitFactionGroup("player").."||"..UnitClass("player").."||"..UnitRace("player");
				JH_Collector.quetes["newquete_"..idquest].qtll = UnitLevel("player").."||"..GetQuestLogRewardMoney();
				local moneytoget = GetQuestLogRequiredMoney();
				if moneytoget > 0 then
					JH_Collector.quetes["newquete_"..idquest].qtgsous = moneytoget;
				end
				JHO_DumpCoList("quetes",JHC_CleanLevel(questLogTitleText));
			else
				JH_Collector.quetes["newquete_"..idquest].qtid = questId.."||"..questLvl;
				JH_Collector.quetes["newquete_"..idquest].qdaily = isDaily;
			end
			JH_Collector.quetes["newquete_"..idquest].qthl = UnitLevel("player").."||"..GetQuestLogRewardMoney();
			JH_Collector.quetes["newquete_"..idquest].qtlog = 1;
			local timer = GetQuestLogTimeLeft();
			if timer then
				if not JH_Collector.quetes["newquete_"..idquest].qttimer then
					JH_Collector.quetes["newquete_"..idquest].qttimer = timer;
				end
			end
			if GetQuestLogPushable() and GetNumPartyMembers() > 0 then
				JH_Collector.quetes["newquete_"..idquest].qtshare = 1;
			end
			if spelltexture then
				spelltexture = string.gsub(spelltexture,"Interface\\Icons\\","");
				local spellinfo = JHC_CleanMe(spellname).."||"..spelltexture.."||"..isTradeskillSpell;
				JH_Collector.quetes["newquete_"..idquest].qtspell = spellinfo;
			end
			JH_Collector.quetes["newquete_"..idquest].qtlogs = CurrentHeader.."||"..questTag.."||"..level.."||"..suggestedGroup;
			local listreward = JHC_GetLogReward();
			if listreward then
				JH_Collector.quetes["newquete_"..idquest].qtreward = listreward;
			end
			local liststep = JHC_GetQLBoard(i);
			if liststep then
				JH_Collector.quetes["newquete_"..idquest].qtlb = liststep;
			end
		end
	end
end

function JHC_QuestProgress()
	if IsQuestCompletable() then
		JHC_Target();
		local source = JHC_GetQuestSource();
		if source == nil then
			return;
		end
		local JHcp = JHC_CleanMe(UnitName("player")).."||"..JHC_CleanMe(GetCVar("realmName"));
		local JHC_TitreText = JHC_CleanMe(JHC_CleanLevel(GetTitleText()));
		local questfound = nil;
		local instafound = nil;
		for i=1, JH_Main.totquest, 1 do
			if JH_Collector.quetes["newquete_"..i] then
				if JH_Collector.quetes["newquete_"..i].qttitre == JHC_TitreText then
					if JH_Collector.quetes["newquete_"..i].qtwho == JHcp then
						if JH_Collector.quetes["newquete_"..i].qtlog == 1 and JH_Collector.quetes["newquete_"..i].qtinsta == 0 then
							questfound = i;
						end
						if JH_Collector.quetes["newquete_"..i].qtlog == 0 and JH_Collector.quetes["newquete_"..i].qtinsta == 1 then
							instafound = i;
						end
					end
				end
			end
		end
		if questfound then
			local listneeded = JHC_GetReqItems();
			if listneeded == nil then
				return;
			else
				if not JH_Collector.quetes["newquete_"..questfound].qtneeded then
					JH_Collector.quetes["newquete_"..questfound].qtneeded = listneeded;
				end
			end
		end
		if instafound == nil and questfound == nil then
			local listneeded = JHC_GetReqItems();
			if listneeded == nil then
				return;
			else
				local idquest = JH_Main.totquest + 1;
				JH_Main.totquest = idquest;
				local JHC_ProgressText = JHC_CleanMe(GetProgressText());
				JH_Collector.quetes["newquete_"..idquest] = {};
				JH_Collector.quetes["newquete_"..idquest].qtinsta = 1;
				JH_Collector.quetes["newquete_"..idquest].qtlog = 0;
				JH_Collector.quetes["newquete_"..idquest].qtwho = JHcp;
				JH_Collector.quetes["newquete_"..idquest].qttitre = JHC_TitreText;
				JH_Collector.quetes["newquete_"..idquest].qttexte = JHC_ProgressText;
				JH_Collector.quetes["newquete_"..idquest].qtsource = source;
				JH_Collector.quetes["newquete_"..idquest].qtside = UnitFactionGroup("player").."||"..UnitClass("player").."||"..UnitRace("player");
				JH_Collector.quetes["newquete_"..idquest].qtll = UnitLevel("player").."||"..GetRewardMoney();
				JH_Collector.quetes["newquete_"..idquest].qthl = UnitLevel("player").."||"..GetRewardMoney();
				JH_Collector.quetes["newquete_"..idquest].qtneeded = listneeded;
				local moneytoget = GetQuestMoneyToGet();
				if moneytoget > 0 then
					JH_Collector.quetes["newquete_"..idquest].qtgsous = moneytoget;
				end
				JHO_DumpCoList("quetes",JHC_CleanLevel(GetTitleText()));
			end
		end
	end
end

function JHC_QuestComplete(arg1)
	JHC_LastQuestComplete = nil;
	JHC_Target();
	local source = JHC_GetQuestSource();
	if source == nil then
		return;
	end
	local JHcp = JHC_CleanMe(UnitName("player")).."||"..JHC_CleanMe(GetCVar("realmName"));
	local JHC_TitreText = JHC_CleanMe(JHC_CleanLevel(GetTitleText()));
	local questfound = nil;
	local instafound = nil;
	for i=1, JH_Main.totquest, 1 do
		if JH_Collector.quetes["newquete_"..i] then
			if JH_Collector.quetes["newquete_"..i].qttitre == JHC_TitreText then
				if JH_Collector.quetes["newquete_"..i].qtwho == JHcp then
					if JH_Collector.quetes["newquete_"..i].qtlog == 1 and JH_Collector.quetes["newquete_"..i].qtinsta == 0 then
						questfound = i;
					end
					if JH_Collector.quetes["newquete_"..i].qtlog == 0 and JH_Collector.quetes["newquete_"..i].qtinsta == 1 then
						instafound = i;
					end
				end
			end
		end
	end
	if questfound and not instafound then
		JHC_LastQuestComplete = questfound;
		JH_Collector.quetes["newquete_"..questfound].qtendsource = source;
		JH_Collector.quetes["newquete_"..questfound].qthl = UnitLevel("player").."||"..GetRewardMoney();
		local listreward = JHC_GetQReward();
		if listreward ~= nil then
			JH_Collector.quetes["newquete_"..questfound].qtreward = listreward;
		end
	end
	if not questfound and instafound then
		JHC_LastQuestComplete = instafound;
		JH_Collector.quetes["newquete_"..instafound].qtendsource = source;
		JH_Collector.quetes["newquete_"..instafound].qthl = UnitLevel("player").."||"..GetRewardMoney();
		local listreward = JHC_GetQReward();
		if listreward ~= nil then
			JH_Collector.quetes["newquete_"..instafound].qtreward = listreward;
		end
	end
end

function JHC_QuestFinished(arg1)
	if JHC_LastQuestComplete ~= nil then
		if not JH_Collector.quetes["newquete_"..JHC_LastQuestComplete].qtendsource then
			JHC_Target();
			local source = JHC_GetQuestSource();
			if source == nil then
				return;
			else
				JH_Collector.quetes["newquete_"..JHC_LastQuestComplete].qtendsource = source;
			end
		end
		local JHC_EndingReward = "";
		if JHC_XPTime+1 > GetTime() then
			JHC_EndingReward = JHC_XP;
		end
		if JHC_FactionGainTime+1 > GetTime() then
			if JHC_EndingReward == "" then
				JHC_EndingReward = JHC_FactionGain;
			else
				JHC_EndingReward = JHC_EndingReward.."||"..JHC_FactionGain;
			end
		end
		if JHC_HonorGainTime+1 > GetTime() then
			if JHC_EndingReward == "" then
				JHC_EndingReward = JHC_HonorGain;
			else
				JHC_EndingReward = JHC_EndingReward.."||"..JHC_HonorGain;
			end
		end
		if JHC_EndingReward ~= "" then
			JH_Collector.quetes["newquete_"..JHC_LastQuestComplete].qtxpandmore = JHC_EndingReward;
			JHC_LastQuestFinished = JHC_LastQuestComplete;
			JHC_LastQuestFinishedTime = GetTime();
			return;
		end
	end
	JHC_LastQuestComplete = nil;
	JHC_LastQuestFinished = nil;
	JHC_LastQuestFinishedTime = 0;
end

function JHC_GetQReward()
	local listreward = nil;
	for i=1, GetNumQuestRewards(), 1 do
		local name,_,numItems,_,_ = GetQuestItemInfo("reward", i);
		local link = GetQuestItemLink("reward", i);
		if link then
			local itemreport = JHC_ProcessItem(link);
			if listreward == nil then
				listreward = "R##"..numItems.."##"..itemreport;
			else
				listreward = listreward.."||R##"..numItems.."##"..itemreport;
			end
		end
	end
	for i=1, GetNumQuestChoices(), 1 do
		local name, _, numItems, _, _ = GetQuestItemInfo("choice", i);
		local link = GetQuestItemLink("choice", i);
		if link then
			local itemreport = JHC_ProcessItem(link);
			if listreward == nil then
				listreward = "C##"..numItems.."##"..itemreport;
			else
				listreward = listreward.."||C##"..numItems.."##"..itemreport;
			end
		end
	end
	return listreward;
end

function JHC_GetLogReward()
	local listreward = nil;
	for i=1, GetNumQuestLogRewards(), 1 do
		local name, _, numItems, _, _ = GetQuestLogRewardInfo(i);
		local link = GetQuestLogItemLink("reward", i);
		if link then
			local itemreport = JHC_ProcessItem(link);
			if listreward == nil then
				listreward = "R##"..numItems.."##"..itemreport;
			else
				listreward = listreward.."||R##"..numItems.."##"..itemreport;
			end
		end
	end
	for i=1, GetNumQuestLogChoices(), 1 do
		local name, _, numItems, _, _ = GetQuestLogChoiceInfo(i);
		local link = GetQuestLogItemLink("choice", i);
		if link then
			local itemreport = JHC_ProcessItem(link);
			if listreward == nil then
				listreward = "C##"..numItems.."##"..itemreport;
			else
				listreward = listreward.."||C##"..numItems.."##"..itemreport;
			end
		end
	end
	return listreward;
end

function JHC_GetQLBoard(quest)
	local liststep = nil;
	for i=1, GetNumQuestLeaderBoards(), 1 do
		local desc, type, done = GetQuestLogLeaderBoard(i, quest);
		if desc and type and desc ~= "Trait" then
			if done == nil then
				done = "encours";
			else
				done = "fini";
			end
			local validating = string.sub(desc, 0, 1);
			if validating ~= " " then
				if liststep == nil then
					liststep = JHC_CleanMe(desc).."##"..type.."##"..done;
				else
					liststep = liststep.."||"..JHC_CleanMe(desc).."##"..type.."##"..done;
				end
			end
		end
	end
	return liststep;
end

function JHC_GetReqItems()
	local listneeded = nil;
	for i=1, GetNumQuestItems(), 1 do
		local name, _, numItems, _, _ = GetQuestItemInfo("required", i);
		local link = GetQuestItemLink("required", i);
		if link then
			local itemreport = JHC_ProcessItem(link);
			if listneeded == nil then
				listneeded = numItems.."##"..itemreport;
			else
				listneeded = listneeded.."||"..numItems.."##"..itemreport;
			end
		end
	end
	return listneeded;
end

function JHC_GetQuestID(JHcp,QuestTitre,QuestObj,QuestTexte)
	for i=1, JH_Main.totquest, 1 do
		if JH_Collector.quetes["newquete_"..i] then
			if JH_Collector.quetes["newquete_"..i].qtwho == JHcp then
				if JH_Collector.quetes["newquete_"..i].qttitre == QuestTitre then
					if JH_Collector.quetes["newquete_"..i].qtobj == QuestObj then
						if JH_Collector.quetes["newquete_"..i].qttexte == QuestTexte then
							if JH_Collector.quetes["newquete_"..i].qtinsta == 0 then
								return i;
							end
						end
					end
				end
			end
		end
	end
end

function JHC_GetQuestSource()
	if UnitIsPlayer("npc") then
		return nil;
	end
	local rz, sz, x, y, cont = JHC_GetInfoLoc();
	local cible = UnitName("npc");
	local cibleReport = JHC_CleanMe(cible);
	local source = nil;
	JHC_Target();
	if UnitIsFriend("player","npc") or UnitReaction("player", "npc") == 4 then
		local npcid = JHC_GetUnitId("target");
		source = "pnj||"..cibleReport.."||"..npcid.."||"..rz;
	end
	if source == nil then
		for bagNum = 0, 4 do
			local bagname = GetBagName(bagNum);
			local bagNum_Slots = GetContainerNumSlots(bagNum);
			if bagname then
				for bagItem = 1, bagNum_Slots do
					local BagitemLink = GetContainerItemLink(bagNum, bagItem);
					if BagitemLink then
						for name in string.gmatch(BagitemLink, "|c%x+|Hitem:%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+|h%[(.-)%]|h|r") do
							if name == cible then
								for i=2, GameTooltip:NumLines() do
									local TextLeft = getglobal("GameTooltipTextLeft"..i):GetText()
									JHC_Debug("TextLeft : "..TextLeft);
									if TextLeft == "Cet objet permet de lancer une qu\195\170te" then
										itemreport = JHC_ProcessItem(BagitemLink);
										source = "objetbag||"..itemreport;
									end
								end
							end
						end
					end
				end
			end
		end
	end
	if source == nil then
		if hastarget == nil then
			local foundinbag = 0;
			for bagNum = 0, 4 do
				local bagname = GetBagName(bagNum);
				local bagNum_Slots = GetContainerNumSlots(bagNum);
				if bagname then
					for bagItem = 1, bagNum_Slots do
						local BagitemLink = GetContainerItemLink(bagNum, bagItem);
						if BagitemLink then
							for name in string.gmatch(BagitemLink, "|c%x+|Hitem:%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+|h%[(.-)%]|h|r") do
								if name == cible then
									foundinbag=1;
								end
							end
						end
					end
				end
			end
			if foundinbag == 0 then
				local inerte = JHC_Inerte();
				source = "objetworld||"..cibleReport.."||"..rz;
			end
		end
	end
	-- JHC_Debug("TARGET : QTSource +"..source.."+");
	return source;
end

function JHC_XPGain(arg1)
	if arg1 then
		if string.find(arg1, "Vous gagnez (%d+) points d'exp\195\169rience.") then
			local _,_,valeur = string.find(arg1, "Vous gagnez (%d+) points d'exp\195\169rience.");
			if tonumber(valeur) > 0 then
				JHC_XP = "XP##"..valeur;
				JHC_XPTime = GetTime();
			end
		end
	end
end

function JHC_CombatTxt(arg1,arg2,arg3)
	if arg1 == "FACTION" then
		if UnitRace("player") == "Humain" or UnitRace("player") == "Humaine" then
			arg3 = math.floor(arg3/1.1 + 0.5);
		end
		if (JHC_FactionGainTime+1) > GetTime() then
			JHC_FactionGain = JHC_FactionGain.."||F##"..JHC_CleanMe(arg2).."##"..arg3;
			JHC_FactionGainTime = GetTime();
		else
			JHC_FactionGain = "F##"..JHC_CleanMe(arg2).."##"..arg3;
			JHC_FactionGainTime = GetTime();
		end
	end
	if arg1 == "HONOR" then
		if (JHC_HonorGainTime+1) > GetTime() then
			JHC_HonorGain = JHC_HonorGain.."||H##"..JHC_CleanMe(arg2).."##"..arg3;
			JHC_HonorGainTime = GetTime();
		else
			JHC_HonorGain = "H##"..JHC_CleanMe(arg2).."##"..arg3;
			JHC_HonorGainTime = GetTime();
		end
	end
end

-- =================
-- ===== Tradeskills
-- =================

function JHC_Tradeskill()
	if IsTradeSkillLinked() then
		-- nothing
	else
		local tradeskillName,_,_ = GetTradeSkillLine();
		local tradeskillName = JHC_CleanMe(tradeskillName);
		local CurrentHeader = "";
		for i=1, GetNumTradeSkills(), 1 do
			local skillName, skillType,_,_,_ = GetTradeSkillInfo(i);
			local skillName = JHC_CleanMe(skillName);
			local skillType = JHC_CleanMe(skillType);
			if skillType == "header" then
				CurrentHeader = skillName;
			else
				local link = GetTradeSkillItemLink(i);
				if link then
					-- item
					if ( string.sub(link,13,17) == "item:" ) then
						local itemreport = JHC_ProcessItem(link);
						if itemreport then
							local minMade, maxMade = GetTradeSkillNumMade(i);
							local tools = BuildColoredListString(GetTradeSkillTools(i));
							if tools then
								tools = string.gsub(tools, "|cffff2020", "");
								tools = string.gsub(tools, "|r", "");
							else
								tools = "NULL";
							end
							if not JH_Collector.ts["tsitem_"..itemreport] then
								JH_Collector.ts["tsitem_"..itemreport] = {};
								JHO_DumpCoList("ts",tradeskillName.." : "..link);
							end
							JH_Collector.ts["tsitem_"..itemreport].tsinfos = tradeskillName.."||"..CurrentHeader.."||"..skillName.."||"..itemreport.."||"..minMade.."||"..maxMade.."||"..JHC_CleanMe(tools);
							local numReagents = GetTradeSkillNumReagents(i);
							for j=1, numReagents, 1 do
								local _,_,reagentCount,_ = GetTradeSkillReagentInfo(i, j);
								local Reagentlink = GetTradeSkillReagentItemLink(i, j);
								if Reagentlink then
									local ReagentReport = JHC_ProcessItem(Reagentlink);
									if not JH_Collector.ts["tsitem_"..itemreport].tscompo then
										JH_Collector.ts["tsitem_"..itemreport].tscompo = {};
									end
									JH_Collector.ts["tsitem_"..itemreport].tscompo["tscompo_"..ReagentReport] = ReagentReport.."||"..reagentCount;
								end
							end
						end
					-- other
					else
						for color, id, nom in string.gmatch(link, "|c(%x+)|Henchant:(%d+)|h%[(.+)%]|h|r") do
							local minMade, maxMade = GetTradeSkillNumMade(i);
							local tools = BuildColoredListString(GetTradeSkillTools(i));
							if tools then
								tools = string.gsub(tools, "|cffff2020", "");
								tools = string.gsub(tools, "|r", "");
							else
								tools = "NULL";
							end
							if not JH_Collector.ts["tsitem_"..id] then
								JH_Collector.ts["tsitem_"..id] = {};
								JHO_DumpCoList("ts",id.." : "..link);
							end
							JH_Collector.ts["tsitem_"..id].tsinfos = tradeskillName.."||"..CurrentHeader.."||"..skillName.."||"..id.."||"..minMade.."||"..maxMade.."||"..JHC_CleanMe(tools);
							JHC_DumpTooltip("enchant",id);
							local ttip = JHC_GetTooltip();
							ttip = string.gsub(ttip, "|cffff2020", "");
							ttip = string.gsub(ttip, "|r", "");
							JH_Collector.ts["tsitem_"..id].ttip = ttip;
							local numReagents = GetTradeSkillNumReagents(i);
							for j=1, numReagents, 1 do
								local _,_,reagentCount,_ = GetTradeSkillReagentInfo(i, j);
								local Reagentlink = GetTradeSkillReagentItemLink(i, j);
								if Reagentlink then
									local ReagentReport = JHC_ProcessItem(Reagentlink);
									if not JH_Collector.ts["tsitem_"..id].tscompo then
										JH_Collector.ts["tsitem_"..id].tscompo = {};
									end
									JH_Collector.ts["tsitem_"..id].tscompo["tscompo_"..ReagentReport] = ReagentReport.."||"..reagentCount;
								end
							end
						end
					end
				end
			end
		end
	end
end


-- ======================
-- ===== pnjs interactifs
-- ======================

function JHC_Shop()
	JHC_Target();
	local target = JHC_CleanMe(UnitName("NPC"));
	local report = "vendeur_"..JHC_CleanMe(UnitName("NPC"));
	if not JH_Collector.vendu[report] then
		JH_Collector.vendu[report] = {};
	end
	local sold, factionGroup;
	if UnitFactionGroup("player") == "Alliance" then
		factionGroup = "A";
	else
		factionGroup = "H";
	end
	for i=1, GetMerchantNumItems(), 1 do
		local link = GetMerchantItemLink(i);
		if link then
			local itemreport = JHC_ProcessItem(link);
			local _, _, price, quantity, numAvailable, _, extendedCost = GetMerchantItemInfo(i);
			sold = target.."||"..itemreport.."||"..quantity.."||"..numAvailable.."||"..price;
			if extendedCost then
				local honorPoints, arenaPoints, itemCount = GetMerchantItemCostInfo(i);
				sold = sold.."||"..factionGroup..":"..honorPoints;
				sold = sold.."||"..factionGroup..":"..arenaPoints;
				if itemCount > 0 then
					for j=1, itemCount, 1 do
						itemTexture, itemValue = GetMerchantItemCostItem(i, j);
						if itemTexture then
							JHC_CleanCollectorTTip();
							JudgeHypeCollectorTooltip:SetOwner(UIParent, "ANCHOR_NONE");
							JudgeHypeCollectorTooltip:SetMerchantCostItem(i,j);
							local _, costlink = JudgeHypeCollectorTooltip:GetItem();
							if costlink then
								local costreport = JHC_ProcessItem(costlink);
								if j == 1 then
									sold = sold.."||"..j.."_"..itemValue.."_"..costreport;
								else
									sold = sold.."##"..j.."_"..itemValue.."_"..costreport;
								end
							end
						else
							sold = sold.."||NULL";
						end
						
					end
				end
			else
				sold = sold.."||"..factionGroup..":0||"..factionGroup..":0||NULL";
			end
			if not JH_Collector.vendu[report]["vend_"..itemreport] then
				JHO_DumpCoList("ventes", link);
			end
			JH_Collector.vendu[report]["vend_"..itemreport] = sold;
		end
	end
end

function JHC_ShopSell()
	local IsInBag = 0;
	for bagNum=0, 4 do
		local bagname = GetBagName(bagNum);
		local bagNum_Slots = GetContainerNumSlots(bagNum);
		if bagname then
			for bagItem=1, bagNum_Slots, 1 do
				local _,itemCount,_,_,_ = GetContainerItemInfo(bagNum, bagItem);
				local BagitemLink = GetContainerItemLink(bagNum, bagItem);
				if BagitemLink then
					local Report = JHC_ProcessItem(BagitemLink);
               		JHC_LastSellValue = 0;
					JHC_CleanTTip();
					JudgeHypeTooltip:SetBagItem(bagNum, bagItem);
					if JHC_LastSellValue ~= 0 then
						JHC_LastSellValue = JHC_LastSellValue/itemCount;
						if not JH_Collector.selling["selling_"..Report] then
							JH_Collector.selling["selling_"..Report] = Report.."||"..JHC_LastSellValue.."||"..JHC_LastSellValue;
						else
							local a,b,c;
							for a, b, c in string.gmatch(JH_Collector.selling["selling_"..Report], "(.+)||(%d+)||(%d+)") do
								if tonumber(c)<JHC_LastSellValue then c = JHC_LastSellValue; end
								if tonumber(b)>JHC_LastSellValue then b = JHC_LastSellValue; end
								local newstring = a.."||"..b.."||"..c;
								JH_Collector.selling["selling_"..Report] = newstring;
							end
						end
					end
					JHC_CleanTTip();
				end
			end
		end
	end
end

function JHC_Trainer()
	JHC_Target();
	local target = JHC_CleanMe(UnitName("NPC"));
	local report = "trainer_"..JHC_CleanMe(UnitName("NPC"));
	SetTrainerServiceTypeFilter("available",1);
	SetTrainerServiceTypeFilter("unavailable",1);
	SetTrainerServiceTypeFilter("used",1);
	local what = nil;
	local whatcat = nil;
	if IsTradeskillTrainer() then
		for i=1, GetNumTrainerServices(), 1 do
			SelectTrainerService(i);
			local CTskill = nil;
			local CTskill,_,_ = GetTrainerServiceSkillReq(i);
			if CTskill then
				if not what then
					what = JHC_CleanMe(CTskill);
					whatcat = "TS";
				end
			end
		end
	end
	if what == nil then
		local JHC_Greeting = GetTrainerGreetingText();
		local PlayedClass = { "chaman","chamane","chasseur","chasseresse","d\195\169moniste","druide","guerrier","guerri\195\168re","mage","paladin","pr\195\170tre","pr\195\170tresse","voleur","voleuse" };
		for i, value in pairs(PlayedClass) do
			if string.find(JHC_Greeting,PlayedClass[i]) then
				what = PlayedClass[i];
				whatcat = "CP";
			end
		end
		if what == nil or whatcat == nil then
			what = "OTHER";
			whatcat = "OTHER";
		end
	end
	if what == nil or whatcat == nil then
		return;
	end
	local numlearn = 0;
	for i=1, GetNumTrainerServices(), 1 do
		local requirements="";
		local serviceName, serviceInfos, serviceType, _ = GetTrainerServiceInfo(i);
		if serviceType == "header" then
			CurrentHeader = JHC_CleanMe(serviceName);
		else
			numlearn = numlearn + 1;
			serviceName = JHC_CleanMe(serviceName);
			local moneyCost,_,_ = GetTrainerServiceCost(i);
			local icone = GetTrainerServiceIcon(i);
			if icone then
				icone = string.gsub(icone,"Interface\\Icons\\","");
				local skill, rank, _ = GetTrainerServiceSkillReq(i);
				if not skill then
					skill = "NULL";
					rank = "NULL";
				end
				if whatcat == "TS" then
					local description = JHC_CleanMe(GetTrainerServiceDescription(i));
					if description == "" then description = "NULL"; end
					if not JH_Collector.trainers[report] then
						JH_Collector.trainers[report] = {};
					end
					if not JH_Collector.trainers[report]["train_"..numlearn] then
						JH_Collector.trainers[report]["train_"..numlearn] = target.."||"..whatcat.."||"..what.."||"..numlearn.."||"..CurrentHeader.."||"..serviceName.."||"..icone.."||"..moneyCost.."||"..skill.."||"..rank.."||"..description;
						JHO_DumpCoList("trainers",serviceName);
					end
				else
					if serviceInfos == "" then serviceInfos = "norank"; end
					if not JH_Collector.trainers[report] then
						JH_Collector.trainers[report] = {};
					end
					if not JH_Collector.trainers[report]["train_"..numlearn] then
						JH_Collector.trainers[report]["train_"..numlearn] = target.."||"..whatcat.."||"..what.."||"..numlearn.."||"..CurrentHeader.."||"..serviceName.."||"..icone.."||"..moneyCost.."||"..skill.."||"..rank.."||"..serviceInfos;
						JHO_DumpCoList("trainers",serviceName);
					end
				end
			end
		end
	end
	SetTrainerServiceTypeFilter("available",1);
	SetTrainerServiceTypeFilter("unavailable",1);
	SetTrainerServiceTypeFilter("used",0);
end

-- =====================
-- ===== Collecte divers
-- =====================

function JHC_MonsterTalk(type,arg1,arg2,arg3)
	local what = JHC_CleanMe(arg1);
	local who = JHC_CleanMe(arg2);
	local lang = JHC_CleanMe(arg3);
	if lang == "" then lang = "NULL"; end
	local result = type.."||"..who.."||"..lang.."||"..JHC_CleanMe(UnitName("player")).."||"..what;
	local resultfound = 0;
	local totentry = JH_Main.tottalk;
	for i=1, totentry, 1 do
		if JH_Collector.talk["talked_"..i] == result then
			resultfound = 1;
		end
	end
	if resultfound == 0 then
		local tot = totentry+1;
		JH_Main.tottalk = tot;
		JH_Collector.talk["talked_"..tot] = result;
	end
end

function JHC_Reader()
	local creatorName = ItemTextGetCreator();
	if creatorName == nil then
		local item = JHC_CleanMe(ItemTextGetItem());
		local material = ItemTextGetMaterial();
		local page = ItemTextGetPage();
		if not material then
			material = "Parchemin";
		else
			material = JHC_CleanMe(material);
		end
		local rz, sz, x, y = JHC_GetInfoLoc();
		local toconvert = ItemTextGetText();
		if string.find(toconvert,"HTML") then
			toconvert = "HTMLTEXT";
		else
			toconvert = JHC_CleanMe(toconvert);
		end
		local IsInBag = nil;
		local itemreport = nil;
		for bagNum = 0, 4 do
			local bagname = GetBagName(bagNum);
			local bagNum_Slots = GetContainerNumSlots(bagNum);
			if bagname then
				for bagItem = 1, bagNum_Slots do
					local BagitemLink = GetContainerItemLink(bagNum, bagItem);
					if BagitemLink then
						itemreport = JHC_ProcessItem(BagitemLink);
						local controlename = GetItemInfo(BagitemLink);
						if ItemTextGetItem() == controlename then
							IsInBag=itemreport;
						end
					end
				end
			end
		end
		if IsInBag == nil then
			if not JH_Collector.reader["reader_"..rz.."_"..item.."_page"..page] then
				JHC_Debug("READER OUT +"..item);
				JH_Collector.reader["reader_"..rz.."_"..item.."_page"..page] = "MONDE||"..item.."||"..material.."||"..page.."||"..rz.."||"..sz.."||"..x..":"..y.."||"..toconvert;
			end
		end
	end
end

function JHC_SelfDamage(hit1,hit2,hit3,hit4,hit5,hit6,hit7,hit8,hit9,hit10,hit11,hit12,hit13,hit14,hit15,hit16,hit17,hit18,hit19)
	if hit2 == "SPELL_AURA_APPLIED" then
		if arg12=="BUFF" then
			if hit7 == UnitName("player") then
				for i=1,40 do
					local name,rank,iconTexture,count,debuffType,duration,_,_,steal = UnitAura("player",i);
					if hit10 == name then
						if not JH_Collector.buffs["buff_"..hit9] then
							if rank == nil or rank == "" then rank = "none"; end
							if count == nil or count == "" then count = "none"; end
							if debuffType == nil or debuffType == "" then debuffType = "none"; end
							if duration == nil or duration == "" then duration = "none"; end
							if steal == nil or steal == "" then steal = "none"; end
							iconTexture = string.gsub(iconTexture,"Interface\\Icons\\","");
							JH_Collector.buffs["buff_"..hit9] = {};
							JH_Collector.buffs["buff_"..hit9]["buffinfos"] = hit9.."||"..hit12.."||"..hit11.."||"..JHC_CleanMe(hit10).."||"..rank.."||"..iconTexture.."||"..count.."||"..duration.."||"..debuffType.."||"..steal;
							JHC_DumpTooltip("buff",i);
							JH_Collector.buffs["buff_"..hit9]["buffttip"] = JHC_GetTooltip();
						end
						-- JHC_Debug(hit12.."("..hit10..") ");
					end
				end
			elseif hit7 == UnitName("target") and hit8 == 68168 then
				for i=1,40 do
					local name,rank,iconTexture,count,debuffType,duration,_,_,steal = UnitBuff("target",i);
					if hit10 == name then
						if not JH_Collector.buffs["buff_"..hit9] then
							if rank == nil or rank == "" then rank = "none"; end
							if count == nil or count == "" then count = "none"; end
							if debuffType == nil or debuffType == "" then debuffType = "none"; end
							if duration == nil or duration == "" then duration = "none"; end
							if steal == nil or steal == "" then steal = "none"; end
							iconTexture = string.gsub(iconTexture,"Interface\\Icons\\","");
							JH_Collector.buffs["buff_"..hit9] = {};
							JH_Collector.buffs["buff_"..hit9]["buffinfos"] = hit9.."||"..hit12.."||"..hit11.."||"..JHC_CleanMe(hit10).."||"..rank.."||"..iconTexture.."||"..count.."||"..duration.."||"..debuffType.."||"..steal;
							JHC_DumpTooltip("bufftarget",i);
							JH_Collector.buffs["buff_"..hit9]["buffttip"] = JHC_GetTooltip();
						end
						-- JHC_Debug(hit12.."("..hit10..") ");
					end
				end
			end
		end
		if arg12=="DEBUFF" then
			if hit7 == UnitName("player") then
				for i=1,40 do
					local name,rank,iconTexture,count,debuffType,duration,_,_,steal = UnitDebuff("player",i);
					if hit10 == name then
						if not JH_Collector.buffs["buff_"..hit9] then
							if rank == nil or rank == "" then rank = "none"; end
							if count == nil or count == "" then count = "none"; end
							if debuffType == nil or debuffType == "" then debuffType = "none"; end
							if duration == nil or duration == "" then duration = "none"; end
							if steal == nil or steal == "" then steal = "none"; end
							iconTexture = string.gsub(iconTexture,"Interface\\Icons\\","");
							JH_Collector.buffs["buff_"..hit9] = {};
							JH_Collector.buffs["buff_"..hit9]["buffinfos"] = hit9.."||"..hit12.."||"..hit11.."||"..JHC_CleanMe(hit10).."||"..rank.."||"..iconTexture.."||"..count.."||"..duration.."||"..debuffType.."||"..steal;
							JHC_DumpTooltip("debuff",i);
							JH_Collector.buffs["buff_"..hit9]["buffttip"] = JHC_GetTooltip();
						end
						-- JHC_Debug(hit12.."("..hit10..") ");
					end
				end
			elseif hit7 == UnitName("target") and hit8 == 68168 then
				for i=1,40 do
					local name,rank,iconTexture,count,debuffType,duration,_,_,steal = UnitDebuff("target",i);
					if hit10 == name then
						if not JH_Collector.buffs["buff_"..hit9] then
							if rank == nil or rank == "" then rank = "none"; end
							if count == nil or count == "" then count = "none"; end
							if debuffType == nil or debuffType == "" then debuffType = "none"; end
							if duration == nil or duration == "" then duration = "none"; end
							if steal == nil or steal == "" then steal = "none"; end
							iconTexture = string.gsub(iconTexture,"Interface\\Icons\\","");
							JH_Collector.buffs["buff_"..hit9] = {};
							JH_Collector.buffs["buff_"..hit9]["buffinfos"] = hit9.."||"..hit12.."||"..hit11.."||"..JHC_CleanMe(hit10).."||"..rank.."||"..iconTexture.."||"..count.."||"..duration.."||"..debuffType.."||"..steal;
							JHC_DumpTooltip("debufftarget",i);
							JH_Collector.buffs["buff_"..hit9]["buffttip"] = JHC_GetTooltip();
						end
						-- JHC_Debug(hit12.."("..hit10..") ");
					end
				end
			end
		end
	end
	if time() > (JHC_GlobalEnteringWorld+30) then
		local report = nil;
		local amount = nil;
		local confirm = nil;
		local isnpc = nil;
		if hit3 then
			-- 0xF13 -- NPC 
			-- 0xF53 -- NPC 
			-- 0xF14 -- PET 
			-- 0xF54 -- PET 
			-- 0x000 -- Player
			confirm = string.sub(hit3,1,5);
			if confirm == "0xF13" or confirm == "0xF53" then
				isnpc=1;
			end
		end
		if hit2 == "SWING_DAMAGE" and hit7 == UnitName("player") and hit8 == 1297 and isnpc == 1 then
			if hit15 == nil then
				hit15=0;
				if hit10 == nil then hit10=0; end
				if hit11 == nil then hit11=0; end
				if hit12 == nil then hit12=0; end
				if hit13 == nil then hit13=0; end
				if hit14 == nil then hit14=0; end
				if hit16 == nil then hit16=0; end
				hit9 = hit9+hit11+hit12+hit13;
				if hit10 == 1 then
					local pourcentred = JHC_ArmorReduction();
					hit9 = floor((hit9 + ((hit9/100)*pourcentred) + 0.5));
				end
				amount = hit9;
				local plvl = UnitLevel("player");
				local difficulty = JHC_GetDifficulty();
				report = "BLANK||"..plvl.."||"..difficulty.."||"..hit14.."||"..hit16.."||"..JHC_CleanMe(hit4).."||NULL||NULL||"..hit10;
				-- JHC_Debug("BLANK : "..report);
			end
		end
		if hit2 == "SPELL_DAMAGE" and hit7 == UnitName("player") and hit8 == 1297 and isnpc == 1 then
			if hit18 == nil then
				hit18=0;
				if hit13 == nil then hit13=0; end
				if hit14 == nil then hit14=0; end
				if hit15 == nil then hit15=0; end
				if hit16 == nil then hit16=0; end
				if hit17 == nil then hit17=0; end
				if hit19 == nil then hit19=0; end
				hit12 = hit12+hit14+hit15+hit16;
				if hit13 == 1 then
					local pourcentred = JHC_ArmorReduction();
					hit12 = floor((hit12 + ((hit12/100)*pourcentred) + 0.5));
				end
				amount = hit12;
				local plvl = UnitLevel("player");
				local difficulty = JHC_GetDifficulty();
				report = "MAGIC||"..plvl.."||"..difficulty.."||"..hit17.."||"..hit19.."||"..JHC_CleanMe(hit4).."||"..hit9.."||"..JHC_CleanMe(hit10).."||"..hit13;
				-- JHC_Debug("MAGIC : "..report);
			end
		end
		if hit2 == "SPELL_PERIODIC_DAMAGE" and hit7 == UnitName("player") and hit8 == 1297 and isnpc == 1 then
			if hit18 == nil then
				hit18=0;
				if hit13 == nil then hit13=0; end
				if hit14 == nil then hit14=0; end
				if hit15 == nil then hit15=0; end
				if hit16 == nil then hit16=0; end
				if hit17 == nil then hit17=0; end
				if hit19 == nil then hit19=0; end
				hit12 = hit12+hit14+hit15+hit16;
				if hit13 == 1 then
					local pourcentred = JHC_ArmorReduction();
					hit12 = floor((hit12 + ((hit12/100)*pourcentred) + 0.5));
				end
				amount = hit12;
				local plvl = UnitLevel("player");
				local difficulty = JHC_GetDifficulty();
				report = "PERIODIC||"..plvl.."||"..difficulty.."||"..hit17.."||"..hit19.."||"..JHC_CleanMe(hit4).."||"..hit9.."||"..JHC_CleanMe(hit10).."||"..hit13;
				-- JHC_Debug("PERIODIC : "..report);
			end
		end
		if hit2 == "SPELL_HEAL" and hit5 == 68168 and hit5 == hit8 then
			if hit13 == nil then hit13=0; end
			amount = hit12;
			local plvl = UnitLevel("player");
			local difficulty = JHC_GetDifficulty();
			report = "SELFHEAL||"..plvl.."||"..difficulty.."||"..hit13.."||NULL||"..JHC_CleanMe(hit4).."||"..hit9.."||"..JHC_CleanMe(hit10).."||"..hit11;
			-- JHC_Debug("SELFHEAL : "..report.."("..amount..")");
		end
		if report then
			local found = nil;
			for i=1, JH_Main.tothits, 1 do
				for compare in string.gmatch(JH_Collector.hits["hits_"..i], "%d+||%d+||%d+||%d+||(.+)") do
					if compare == report then
						found = i;
					end
				end
			end
			if found then
				local a,b,c,d,e;
				for a, b, c, d, e in string.gmatch(JH_Collector.hits["hits_"..found], "(%d+)||(%d+)||(%d+)||(%d+)||(.+)") do
					a = tonumber(a) + 1;
					b = tonumber(b) + tonumber(amount);
					if tonumber(c) > tonumber(amount) then c = amount; end
					if tonumber(amount) > tonumber(d) then d = amount; end
					local newstring = a.."||"..b.."||"..c.."||"..d.."||"..e;
					JH_Collector.hits["hits_"..found] = newstring;
				end
			else
				JH_Main.tothits = JH_Main.tothits + 1;
				JH_Collector.hits["hits_"..JH_Main.tothits] = "1||"..amount.."||"..amount.."||"..amount.."||"..report;
			end
		end
	else
		-- JHC_Debug("NO DMG ALLOWED : "..time().." vs"..JHC_GlobalEnteringWorld.."+30");
	end
end

function JHC_SaveFactions()
	local currentheader = "";
	for i=1, GetNumFactions(), 1 do
		local name, description, _, _, _, _, _, _, isHeader, _, _, _, _ = GetFactionInfo(i);
		name = JHC_CleanMe(name);
		if isHeader then
			currentheader = name;
		else
			if not JH_Collector.factions["faction_"..name] then
				if canToggleAtWar == nil then
					canToggleAtWar = 0;
				else
					canToggleAtWar = 1;
				end
				JH_Collector.factions["faction_"..name.."_"..UnitFactionGroup("player")] = currentheader.."||"..name.."||"..UnitFactionGroup("player").."||"..JHC_CleanMe(description);
			end
		end
	end
end

function JHC_ScanBag()
	JHC_Debug("Scanning bag ...");
	if JHC_MaxUpdate > JHC_TotUpdate then
		for bagNum = 0, 4 do
			local bagname = GetBagName(bagNum);
			local bagNum_Slots = GetContainerNumSlots(bagNum);
			if bagname then
				for bagItem = 1, bagNum_Slots do
					local BagitemLink = GetContainerItemLink(bagNum, bagItem);
					if BagitemLink then
						JHC_ProcessItem(BagitemLink);
					end
				end
			end
		end
	end
end

-- ========================
-- ===== fonctions globales
-- ========================
function JHC_ProcessItem(link)
	local color,lien,id,enchant,sock1,sock2,sock3,sock4,sousid,trash,plevel,nom,report,toreturn,towork,duration;
	for color, id, enchant, sock1, sock2, sock3, sock4, sousid, trash, plevel, nom in string.gmatch(link, "|c(%x+)|Hitem:(%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+)|h%[(.+)%]|h|r") do
		report = "obj_"..id..":"..sousid;
		toreturn = id..":"..sousid;
		if tonumber(sousid) == 0 then
			towork = id..":0:0:0:0:0:"..sousid..":0"..plevel;
		else
			towork = id..":0:0:0:0:0:"..sousid..":"..trash..":"..plevel;
		end
		if not JH_Collector.objets[report] then
			local _, _, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, invTexture = GetItemInfo(link);
			if invTexture then
				if itemEquipLoc == "" then itemEquipLoc="NULL"; end
				invTexture = string.gsub(invTexture,"Interface\\Icons\\","");
				JH_Collector.objets[report] = {};
				JH_Collector.objets[report].objinfos = id..":"..sousid.."||"..itemMinLevel.."||"..itemLevel.."||"..itemRarity.."||"..itemType.."||"..itemSubType.."||"..itemEquipLoc.."||"..itemStackCount.."||"..invTexture;
				if itemRarity == 7 then
					JH_Collector.objets[report].objplevel = plevel;
				end
				JHC_DumpTooltip("item",towork);
				JH_Collector.objets[report].objtooltip = JHC_GetTooltip();
				JHO_DumpCoList("objets",link);
			end
		else
			JHC_DumpTooltip("item",towork);
			JH_Collector.objets[report].objtooltip = JHC_GetTooltip();
			local _, duration, _ = GetItemCooldown(link);
			if duration ~= 0 and duration ~= nil then
				if not JH_Collector.objets[report].objcd then
					JH_Collector.objets[report].objcd = duration;
				end
			end
		end
		if tonumber(sousid) ~= 0 then
			local reportspecial = "obj_"..id..":0";
			local tospecial = id..":0:0:0:0:0:0:0:"..plevel;
			if not JH_Collector.objets[reportspecial] then
				local _, _, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, invTexture = GetItemInfo(link);
				if invTexture then
					if itemEquipLoc == "" then itemEquipLoc="NULL"; end
					invTexture = string.gsub(invTexture,"Interface\\Icons\\","");
					JH_Collector.objets[reportspecial] = {};
					JH_Collector.objets[reportspecial].objinfos = id..":0||"..itemMinLevel.."||"..itemLevel.."||"..itemRarity.."||"..itemType.."||"..itemSubType.."||"..itemEquipLoc.."||"..itemStackCount.."||"..invTexture;
					JH_Collector.objets[reportspecial].objvoid = "void";
					JHC_DumpTooltip("item",tospecial);
					JH_Collector.objets[reportspecial].objtooltip = JHC_GetTooltip();
				end
			end
		end
	end
	return toreturn;
end

function JHC_CleanMe(toclean)
	if toclean == nil then toclean=""; end
	return string.gsub(string.gsub(string.gsub(toclean, "\n", "|n|"), "\r", ""),"\"","dbquote");
end

function JHC_CleanItem(toclean)
	if toclean == nil then toclean=""; end
	toclean = string.gsub(toclean, "|cffff2020", "");
	toclean = string.gsub(toclean, "|cff808080", "");
	toclean = string.gsub(toclean, "|r", "");
	toclean = string.gsub(toclean, "\r", "");
	toclean = string.gsub(toclean, "\n", "|br|");
	toclean = string.gsub(toclean, "|n", "|br|");
	toclean = string.gsub(toclean, "\"", "dbquote");
	return toclean;
end

function JHC_CleanLevel(toclean)
	local NewTitre;
	local _, _, niveau, titre = string.find(toclean, "%[(.*)%] (.*)");
	if (titre) then
		NewTitre = titre;
	else
		NewTitre = toclean;
	end
	return NewTitre;
end

function JHC_DumpTooltip(type,cleanlink)
	for i=1,JudgeHypeTooltip:NumLines() do
		getglobal("JudgeHypeTooltipTextLeft"..i):SetText("");
		getglobal("JudgeHypeTooltipTextRight"..i):SetText("");
	end
	JudgeHypeTooltip:SetOwner(UIParent, "ANCHOR_NONE");
	if type == "item" then JudgeHypeTooltip:SetHyperlink("item:"..cleanlink); end
	if type == "pnj" then JudgeHypeTooltip:SetUnit("npc"); end
	if type == "target" then JudgeHypeTooltip:SetUnit("target"); end
	if type == "enchant" then JudgeHypeTooltip:SetHyperlink("enchant:"..cleanlink); end
	if type == "buff" then JudgeHypeTooltip:SetUnitBuff("player",cleanlink); end
	if type == "debuff" then JudgeHypeTooltip:SetUnitDebuff("player",cleanlink); end
	if type == "bufftarget" then JudgeHypeTooltip:SetUnitBuff("target",cleanlink); end
	if type == "debufftarget" then JudgeHypeTooltip:SetUnitDebuff("target",cleanlink); end
end

function JHC_GetTooltip()
	local JHttdone = {};
	for i=1,JudgeHypeTooltip:NumLines() do
		local JHtextLeft = nil;
		local JHtextRight = nil;
		local JHtoadd = nil;
		JHtextLeft = getglobal("JudgeHypeTooltipTextLeft"..i);
		JHtextRight = getglobal("JudgeHypeTooltipTextRight"..i);
		if JHtextLeft:GetText() then
			local JHtextL = JHtextLeft:GetText();
			local Color1,Color2,Color3 = JHtextLeft:GetTextColor();
			local color = JHC_RGBPercToHex(Color1,Color2,Color3);
			if color == "fe1f1f" then color = "fefefe"; end
			JHtextL = "["..color.."]"..JHC_CleanItem(JHtextL);
			JHtoadd = JHtextL;
		end
		if JHtextRight:GetText() then
			local JHtextR = JHtextRight:GetText();
			local Color1,Color2,Color3 = JHtextRight:GetTextColor();
			local color = JHC_RGBPercToHex(Color1,Color2,Color3);
			if color == "fe1f1f" then color = "fefefe"; end
			JHtextR = "["..color.."]"..JHC_CleanItem(JHtextR);
			JHtoadd = JHtoadd.."---"..JHtextR;
		end
		if JHtoadd then
			table.insert(JHttdone,JHtoadd);
		end
	end
	return table.concat(JHttdone,"|n|");
end

function JHC_GetInfoLoc()
	SetMapToCurrentZone();
	local JH_CurrentRealZoneName,JH_SubZone,JH_Mpx,JH_Mpy,JH_MapContinent,JH_Wpx,JH_Wpy,JH_DungeonLevel;
	JH_MapContinent = GetCurrentMapContinent();
	JH_CurrentRealZoneName = JHC_CleanMe(GetRealZoneText());
	JH_SubZone = JHC_CleanMe(GetSubZoneText());
	if JH_SubZone == nil or JH_SubZone == "" then
		JH_SubZone = JHC_CleanMe(GetMinimapZoneText());
		if JH_SubZone == nil or JH_SubZone == "" then
			JH_SubZone = JH_CurrentRealZoneName;
		end
	end
	JH_Mpx, JH_Mpy = GetPlayerMapPosition("player");
	SetMapZoom(JH_MapContinent);
	JH_Wpx, JH_Wpy = GetPlayerMapPosition("player");
	SetMapToCurrentZone();
	JH_DungeonLevel = GetCurrentMapDungeonLevel();
	if JH_DungeonLevel == nil then JH_DungeonLevel = 0; end
	JH_Mpx = floor((JH_Mpx*100)+ 0.5);
	JH_Mpy = floor((JH_Mpy*100)+ 0.5);
	JH_Wpx = floor((JH_Wpx*100)+ 0.5);
	JH_Wpy = floor((JH_Wpy*100)+ 0.5);
	-- JHC_Debug("MAPLOC +"..JH_Mpx.."+ +"..JH_Mpy.."+");
	-- JHC_Debug("WORLDLOC +"..JH_Wpx.."+ +"..JH_Wpy.."+");
	return JH_CurrentRealZoneName,JH_SubZone,JH_Mpx,JH_Mpy,JH_MapContinent,JH_Wpx,JH_Wpy,JH_DungeonLevel;
end

function JHC_Location(type,report,rz,sz,x,y,cont,wx,wy,dl)
	if not JH_Collector[type][report].location then
		JH_Collector[type][report].location = {}
	end
	if not JH_Collector[type][report].location["loc_"..rz.."_"..x..":"..y.."_"..dl] then
		JH_Collector[type][report].location["loc_"..rz.."_"..x..":"..y.."_"..dl] = "1".."||"..rz.."||"..sz.."||"..x..":"..y.."||"..cont.."||"..wx..":"..wy.."||"..dl;
		JHO_DumpCoList("locs",""..x..":"..y.." dans "..rz);
	else
		local a,b;
		for a, b in string.gmatch(JH_Collector[type][report].location["loc_"..rz.."_"..x..":"..y.."_"..dl], "(%d+)||(.*)") do
			a = tonumber(a)+1;
			local newstring = a.."||"..b;
			JH_Collector[type][report].location["loc_"..rz.."_"..x..":"..y.."_"..dl] = newstring;
		end
	end
end

function JHC_ResetGlobal()
	JHC_GlobalTimer = 0;
	JHC_GlobalSource = "";
	JHC_GlobalAction = "";
	JHC_GlobalTarget = "";
end

function JHC_CleanTTip()
	for i=1,JudgeHypeTooltip:NumLines() do
		getglobal("JudgeHypeTooltipTextLeft"..i):SetText("");
		getglobal("JudgeHypeTooltipTextRight"..i):SetText("");
	end
end

function JHC_CleanCollectorTTip()
	for i=1,JudgeHypeCollectorTooltip:NumLines() do
		getglobal("JudgeHypeCollectorTooltipTextLeft"..i):SetText("");
		getglobal("JudgeHypeCollectorTooltipTextRight"..i):SetText("");
	end
end

function JHC_OnTooltipAddMoney()
	-- JHC_OnTooltipAddMoneySaved();
    if InRepairMode() then
		return;
	end
	if tonumber(arg1) > 0 then
		JHC_LastSellValue = arg1;
	end
end

function JHC_ArmorReduction()
	local levelModifier = UnitLevel("player");
	local _, armor, _, _, _ = UnitArmor("player");
	if levelModifier > 59 then
		levelModifier = levelModifier + (4.5 * (levelModifier-59));
	end
	local temp = 0.1*armor/(8.5*levelModifier + 40);
	temp = temp/(1+temp);

	if temp < 0 then
		return 0;
	end
	if temp > 0.75 then
		return 75;
	end
	return format("%.2f", (temp*100));
end

function JHC_GetDifficulty()
	local difficulty = nil;
	local inInstance, instanceType = IsInInstance();
	if instanceType ~= "party" and instanceType ~= "raid" then
		difficulty = 0;
		JHC_Debug("DIFF : (0)");
	else
		-- difficulty = GetCurrentDungeonDifficulty();
		if instanceType == "party" then
			difficulty = GetDungeonDifficulty();
		end
		if instanceType == "raid" then
			difficulty = GetRaidDifficulty();
		end
		JHC_Debug("DIFF : "..instanceType.." : ("..difficulty..")");
		if difficulty > 1 then
			local isValid = nil;
			SetMapToCurrentZone();
			local zone = GetRealZoneText();
			if zone == "Repaire d'Onyxia" then isValid = 1; end
			if zone == "La Fournaise du sang" then isValid = 1; end
			if zone == "Les Salles bris\195\169es" then isValid = 1; end
			if zone == "Remparts des Flammes infernales" then isValid = 1; end
			if zone == "Les enclos aux esclaves" then isValid = 1; end
			if zone == "La Basse-tourbi\195\168re" then isValid = 1; end
			if zone == "Le Caveau de la vapeur" then isValid = 1; end
			if zone == "Cryptes Auchena\195\175" then isValid = 1; end
			if zone == "Labyrinthe des ombres" then isValid = 1; end
			if zone == "Les salles des Sethekk" then isValid = 1; end
			if zone == "Tombes-mana" then isValid = 1; end
			if zone == "L'Arcatraz" then isValid = 1; end
			if zone == "La Botanica" then isValid = 1; end
			if zone == "Le M\195\169chanar" then isValid = 1; end
			if zone == "Contreforts de Hautebrande d'antan" then isValid = 1; end
			if zone == "Le Noir Mar\195\169cage" then isValid = 1; end
			if zone == "Terrasse des Magist\195\168res" then isValid = 1; end
			if zone == "Le Nexus" then isValid = 1; end
			if zone == "Le sanctum Obsidien" then isValid = 1; end
			if zone == "Le fort Pourpre" then isValid = 1; end
			if zone == "L'Oculus" then isValid = 1; end
			if zone == "Azjol-N\195\169rub" then isValid = 1; end
			if zone == "Donjon de Drak'Tharon" then isValid = 1; end
			if zone == "Les salles de Pierre" then isValid = 1; end
			if zone == "Gundrak" then isValid = 1; end
			if zone == "Les salles de Foudre" then isValid = 1; end
			if zone == "Donjon d'Utgarde" then isValid = 1; end
			if zone == "Cime d'Utgarde" then isValid = 1; end
			if zone == "L'\195\137puration de Stratholme" then isValid = 1; end
			if zone == "Naxxramas" then isValid = 1; end
			if zone == "Caveau d'Archavon" then isValid = 1; end
			if zone == "Ulduar" then isValid = 1; end
			if zone == "L'\195\169preuve du champion" then isValid = 1; end
			if zone == "L'\195\169preuve du crois\195\169" then isValid = 1; end
			if zone == "L'\195\169preuve du grand crois\195\169" then isValid = 1; end
			if zone == "La Forge des \195\162mes" then isValid = 1; end
			if zone == "Fosse de Saron" then isValid = 1; end
			if zone == "Salles des Reflets" then isValid = 1; end
			if zone == "Citadelle de la Couronne de glace" then isValid = 1; end
			if zone == "Le sanctum Rubis" then isValid = 1; end
			if string.find(zone,"il de l'\195\169ternit\195\169") then isValid = 1; end
			if string.find(zone,"Ahn'kahet") then
				if string.find(zone,"l'Ancien royaume") then
					isValid = 1;
				end
			end
			if isValid == nil then
				difficulty = 1;
				JHC_Debug("ERR : Correction to 1 ("..instanceType..")");
			else
				JHC_Debug("VAL : "..difficulty.." ("..instanceType..")");
			end
		end
	end
	return difficulty;
end

function JHC_ResetTimers()
	JHC_Debug("RESET TIMERS");
	JHC_GlobalOpeningTime = nil;
	JHC_GlobalOpeningAction = nil;
	JHC_GlobalOpeningSource = nil;
end

function JHC_GetUnitId(unit)
	guid = UnitGUID(unit);
	id = tonumber(string.sub(guid,6,12), 16);
	-- DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<JH>|r "..id);
	return id;
end

function JHC_GetQuestId(quest)
	local questid = nil;
	local returnlvl,returnid;
	for _, id, lvl, _ in string.gmatch(quest, "|c(%x+)|Hquest:(%d+):(%-?%d+)|h%[(.+)%]|h|r") do
		returnlvl= lvl;
		returnid = id;
	end
	return returnid,returnlvl;
end

function JHC_Debug(phrase)
	-- DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<JH>|r "..phrase);
end

function JHC_RGBPercToHex(r, g, b)
	r = r <= 1 and r >= 0 and r or 0
	g = g <= 1 and g >= 0 and g or 0
	b = b <= 1 and b >= 0 and b or 0
	return string.format("%02x%02x%02x", r*255, g*255, b*255)
end